image: python:latest

variables:
  PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache/pip"

cache:
  paths:
    - .cache/pip
    - venv/

before_script:
  - python --version  # For debugging
  - pip install virtualenv
  - virtualenv venv
  - source venv/bin/activate

test:
    script:
        - pip install pytest pytest-cov
        - coverage run -m pytest
        - coverage report --omit=venv/*
        - coverage xml

run:
    script:
        - python setup.py bdist_wheel
        - pip install dist/*
    artifacts:
        paths:
            - dist/*.whl
pages:
    script:
        - pip install sphinx sphinxcontrib.napoleon
        - cd docs
        - make html
        - mv build/html ../public/
    artifacts:
        paths:
            - public

